



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>gitea 源码阅读笔记 002 生成无依赖单文件可执行包</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">gitea 源码阅读笔记 002 生成无依赖单文件可执行包</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 13:37:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>gitea bindata static</h1>
<p>gitea 可以通过 <code>make generate</code> 生成一个单文件可执行程序，<br /><br />
该文件不需要任何其它依赖，直接可以单独执行。</p>
<p>对于用户的安装、升级和生成docker image等都会方便很多。</p>
<h2>makefile</h2>
<p>gitea安装指南有说：</p>
<pre class="prettyprint linenums"><code>TAGS=&quot;bindata&quot; make generate build<br />
</code></pre>
<p>那么，上面这句执行后，发生了什么？</p>
<ol><li>强制指定了<code>TAGS</code>变量 makefile里会自动读取</li>
<li>执行任务
<ol><li><code>generate</code> 任务</li>
<li><code>build</code> 任务</li></ol></li></ol>
<h2>generate 任务</h2>
<p>从makefile看</p>
<pre class="prettyprint linenums"><code>GO ?= go

## 使用go list 列出目录中所有导入包<br />
## 过滤掉所有包含 /vendor/ 目录的结果<br />
## 过滤掉 code.gitea.io/gitea/integrations<br />
PACKAGES ?= $(filter-out code.gitea.io/gitea/integrations,$(shell $(GO) list ./... | grep -v /vendor/))

.PHONY: generate<br />
generate:<br />
	@hash go-bindata &gt; /dev/null 2&gt;&amp;1; if [ $$? -ne 0 ]; then \<br />
		$(GO) get -u github.com/jteeuwen/go-bindata/...; \<br />
	fi<br />
	$(GO) generate $(PACKAGES)<br />
</code></pre>
<p>通过注释，基本已经清楚generate需要做的动作了。</p>
<ol><li>列出所有导入包</li>
<li>过滤掉不需要的路径</li>
<li>使用 <code>go generate</code> 指令执行go源码文件内设定的指令</li></ol>
<h2>背景知识</h2>
<ol><li>makefile</p>
<ol><li>hash 指令</li>
<li><a href="https://www.gnu.org/software/make/manual/html_node/Text-Functions.html" rel="external nofollow noreferrer">text functions</a></li></ol></li>
<li>go build tags</li>
<li>go generate</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvz4o9x.html">iOS从零开始学习直播之2&period;采集</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvz5oy9.html">Mysql5&period;7修改默认密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4n5j59.html">html中frameset简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gzow08.html">multiOTP配置安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy0rnm8.html">Halcon与opencv格式的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9622mvq.html">linux（centos6）搭建ftp服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpmo09.html">【CodeForces 599A】D - 特别水的题4- Patrick and Shopping</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdp3o8.html">一个Form中2个按钮，PHP后台如何判断提交的是哪一个按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0rn3wq.html">linux管理网络连接指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yojp5q.html">UIAlertView的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xmd1g9.html">FineUI上传控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z65o39.html">MobaXterm</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpg2k69.html">MySQL数据库存储过程动态表建立&lpar;PREPARE&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylryk9.html">Dubbo性能调优参数及原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpg1j8.html">dede后台删除文章后台还有分页显示解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zom61nq.html">redis的list取出数据方式速度测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gmzzvq.html">HDU - 6357 Hills And Valleys（DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwogwv9.html">STL的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25gxelq.html">learning makefile multiple target</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllpje1q.html">python 爬虫启航</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pw7kn48.html">webpack常用插件配置记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2yly2q.html">ssh连接虚拟机centos</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2jzpy9.html">关于django的一些基础知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjzg7l9.html">&lowbar;&lowbar;FILES&lowbar;&lowbar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwgrd79.html">神州数码广域网PPP封装PAP认证配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o202j8.html">PHP涉及的所有英文单词</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r56kweq.html">win10下VM 中centos 安装共享文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e43xve9.html">css后代选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllw7w1q.html">Linux下安装oracle的步骤和一些问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllw7y0q.html">EasyUI学习总结&lpar;一&rpar;&mdash;&mdash;EasyUI入门</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
